/*------------------------------------------------------------------------------------------*\
 *
\*------------------------------------------------------------------------------------------*/
#ifndef _ENV_H_
#define _ENV_H_

#ifdef CONFIG_OF

extern const struct machine_desc *setup_machine_fdt(unsigned int dt_phys);
extern void __init arm_dt_init_cpu_maps(void);

#if defined(CONFIG_EARLY_PRINTK)
extern int prom_printf(const char *fmt, ...);
#else/*--- #if defined(CONFIG_EARLY_PRINTK) ---*/
#define prom_printf(arg...)
#endif/*--- #else ---*//*--- #if defined(CONFIG_EARLY_PRINTK) ---*/

extern char *prom_getenv(char *name);

/* Memory descriptor management. */
#define PROM_MAX_PMEMBLOCKS    32
struct prom_pmemblock {
        unsigned long base; /* Within KSEG0. */
        unsigned int size;  /* In bytes. */
        unsigned int type;  /* free or prom memory */
};

/*------------------------------------------------------------------------------------------*\
 * Header WLAN - DECT - Config
\*------------------------------------------------------------------------------------------*/
#define AVM_MAX_CONFIG_ENTRIES  8

enum wlan_dect_type {
    WLAN,           /*--- 0 ---*/
    DECT,           /*--- 1 ---*/
    WLAN2,          /*--- 2 ---*/
    ZERTIFIKATE,    /*--- 3 ---*/
    DOCSIS,         /*--- 4 ---*/
    DSL,            /*--- 5 ---*/
    PROLIFIC,       /*--- 6 ---*/
    WLAN_ZIP,       /*--- 7 ---*/
    WLAN2_ZIP,      /*--- 8 ---*/
    MAX_TYPE        /*--- 9 ---*/
};

struct __attribute__ ((packed)) wlan_dect_config {
	unsigned char		Version;	/*--- z.Z. 1 ---*/
	enum  wlan_dect_type	Type :8;	/*--- 0 - WLAN; 1 - DECT ---*/
	unsigned short		Len;		/*--- 384 - WLAN, 128 - DECT ---*/
};

extern void set_wlan_dect_config_address(unsigned int value);
extern int get_wlan_dect_config(enum wlan_dect_type Type, unsigned char *buffer, unsigned int len);
extern int prom_c55_get_base_memory(unsigned int *base, unsigned int *len);

#else /* CONFIG_OF */

static inline const struct machine_desc *setup_machine_fdt(unsigned int dt_phys)
{
	return NULL;
}

static inline void arm_dt_init_cpu_maps(void) { }

#endif
#endif

